<?php
/** This function is a wrapper that will check the video cache first before
    going to the 'net again.  Pass @true for the first arg if you want to
    force a reload.
 */
function get_list($force=false) {
	if(file_exists("cache/videos.txt") && $force==false) return include("cache/videos.txt");
	return rebuild_list(); //caches internally
}

function rebuild_list() {
	$base_url="/WebObjects/MZStore.woa/wa/com.apple.jingle.app.store.DirectAction/viewAllVideos";
	$inc=0;
	$info=array();
	
	
	$contents=download_itunes($base_url);
	while(!preg_match('/(\d+) of \1<\/B>/si', $contents)) {
		$t=new tinyparser($contents);
		if(($tree=$t->getParseTree(false)) !== false) {
			$els=$t->getElementsByString("VBoxView", "minWidth=\"222\" stretchiness=\"1\"");
			foreach($els as $el) {
				$i = $t->innerHTML($el);
				if(preg_match('/url="(.*?)".+?url="(.*?)".+?albumLabelTextColor"><b>(.+?)<\/b><\/setfontstyle.+?albumLabelTextColor">(.+?)<.+?viewgenre id="(.+?)">Genre:  (.+?)<.+?Release Date:[ ]*(.+?)</smi', $i, $m)) {
					/* 1=> view url, 2=>artist + b, 3=>title, 4=>genreid, 5->genre string, 6->release date */
					#echo "Got a match<br />\n";
					if(preg_match("/videoId=(\d+)/i", $m[1], $id)) {
						$videoid=$id[1];
						if(isset($info[$videoid])) {
							echo "<pre>";
							//print_r($m);
							//print_r($info);
							//die("Video $videoid already exists in the array");
							echo "Key {$videoid} already exists<br />\n";
							continue;
						}
						$info[$videoid] = array();
						$info[$videoid]['id'] = $videoid;
						$info[$videoid]['img'] = $m[2];
						$info[$videoid]['title'] = $m[3];
						$info[$videoid]['artist'] = $m[4];
						$info[$videoid]['genre'] = $m[6];
						$info[$videoid]['reldate'] = $m[7];
						list($m, $d, $y) = sscanf($m[7], "%d/%d/%d");
						$info[$videoid]['reltime'] = mktime(0,0,0,$m,$d,$y);
					} else {
						echo "Id request failed - \n";
						print_r($m);
						die();
					}
				} else {
					echo "No match on {$el} ({$i}\n";
					die();
				}
			}
		} else {
			echo "Could not parse document (".strlen($firstpage)." bytes)";
			die();
		}
		$inc++;
		$contents=download_itunes("{$base_url}?sortMode=3&batchNumber={$inc}");
	}
	
	var_save("cache/videos.txt", $info);
	return $info;
}
function var_save($fn, $var) {
	$f=fopen($fn, "w");
	fputs($f,"<"."?php return ".var_export($var,true)."; ?".">");
	fclose($f);
}
?>
