<?php
/** Class tinyparser
 *  Current Issues:
 *    doesn't handle innerHTML properly, because each tag's data is munged together
 * 
 */
$do_demo=false;

if($do_demo) {
	$f=file_get_contents("meghan.html");
	#$f="<p>This is a list:<ul><li>Item <b>one</b></li><li>item two</li><li>item three<br></ul><br>Test</p>";
	$t=new tinyparser($f);
	header("Content-Type: text/html");

	if(($tree=$t->getParseTree(true)) !== false) {
		echo "<pre>";
		prettyTree($tree);
		echo "</pre>";
		#if(($lis = $t->getElementsByTagname("p")) !== false) {
		echo "Old: <code>".htmlspecialchars($f)."</code><br />\n";
		echo "New: <code>".htmlspecialchars($t->innerHTML(0))."</code><br />\n";
		exit();
		
		if(($body = $t->getElementsByTagname("body")) !== false) {
			echo $t->innerHTML($body[0]);
			
		}
		exit();
	
	
		if(($entries = $t->getElementsByString("p","align=\"center\"")) !== false) {
			foreach($entries as $tagid) {
				#echo $tagid.": ".$t->innerHTML($tagid,false)."\n";
				$n=$t->nextSibling($tagid);
				if($n !== false) {
				echo "  $tagid: ".$t->innerHTML($n)."\n";
				}
			}
			#print_r($lis);
		}
	} else {
		echo "Error!<br />\n";
		die($t->getError());
	}

} //end do_demo


function prettyTree($tree, $thisnode=0, $depth=0) {
	if($tree[$thisnode]['nodetype'] == 3) {
		echo str_repeat(" ", $depth * 2).$tree[$thisnode]['tagname']."({$tree[$thisnode]['nodetype']}) {$tree[$thisnode]['cdata']}\n";#."=".join('',$tree[$thisnode]['cdata'])."\n";
	} else {
		echo str_repeat(" ", $depth * 2).$tree[$thisnode]['tagname']."({$tree[$thisnode]['nodetype']})\n";#."=".join('',$tree[$thisnode]['cdata'])."\n";
	}	
	if(!isset($tree[$thisnode]['children'])) return;
	foreach($tree[$thisnode]['children'] as $v) {
		prettyTree($tree, $v, $depth+1);
	}
}


class tinyparser {
	var $rawData;
	var $parseTree;
	var $parsedYet;
	var $err;
	var $errLine;
	var $collapseWhitespace;

	function tinyparser($str, $collapseWhitespace=true) {
		$this->rawData=$str;
		$this->parsedYet=false;
		$this->collapseWhitespace=$collapseWhitespace;
	}
	
	function getParseTree($lenient=false) {
		$loose_tags=array();
		$tags_which_are_selfclosing=array("br", "img", "link","meta","embed");
		$tags_which_probably_miss_the_end=array("a","p","li");
		
		$partially_loose_tags = array("li");
		#$this->parseTree=array();
		
		$tag_stack=array();
		$this->rawData=preg_replace("/<!--[\w\W]*?-->/","", $this->rawData);
		


		$debug=0;
		if(preg_match_all("/<(\/)?(\w+)([^>]*)>([^<]*)/m", $this->rawData, $m /*, PREG_OFFSET_CAPTURE | PREG_PATTERN_ORDER*/ )) {
			$indentation=0;
			$tags = array();
			$parent = 0;
			
			for($i=0; $i<count($m[1]); $i++) {
				//we will reuse $i+1 for the tagid
				$tagid=$i+1;
				$thisTag     = strtolower($m[2][$i]);
				$thisAttrib  = $m[3][$i];
				$thisOpening = $m[1][$i] != "/";
				$thisClosing = strlen($m[1][$i]) > 0;
				$thisSelfClosing = substr($thisAttrib, -1) == "/";//strlen($m[3][$i]) > 0;
				if($thisSelfClosing && $thisClosing) {
					//undefined!!
					die("Tags cannot be both closing and selfclosing -- ".htmlspecialchars($m[0][$i]). " - ".join(',', $tag_stack));
					return false;
				}
				$dataparent=false;
				
				if($thisOpening) {
					if($thisSelfClosing) {
#						echo "S";
						$thisAttrib = rtrim(substr($thisAttrib, 0, -1));
					}
					if($lenient && in_array($thisTag, $tags_which_probably_miss_the_end) && in_array($thisTag, $tag_stack)) {
						//hmm, let's try closing up to this point as a band aid
						$thisSelfClosing=true;
						//				if($m[4][$i] == "something else") {
						//idea: if it's the top on the stack, still get rid of it!
						$handled=0;
						if(array_peek($tag_stack) == $thisTag) {
							//remedy it!
							array_pop($tag_stack);
							$parent=$tags[$parent]['parent'];
							#echo "Popped due to repeated tag";
							$handled=1;
							$dataparent=($parent+2);
						}
						while($handled==0 && array_peek($tag_stack) != $thisTag && count($tag_stack)) {
							if(in_array($thisTag, $tags_which_are_selfclosing)) continue; //already handled!
							$indentation--;
							$t=array_peek($tag_stack);
if($debug)
							echo str_repeat(" ", $indentation*2)."/$t (assumed for /$thisTag double open)<br />\n";
							array_pop($tag_stack);
							$parent=$tags[$parent]['parent'];
						}
						if($handled==1) {
							#$dataparent=$parent;
						} else  {
							array_pop($tag_stack);
							$parent=$tags[$parent]['parent'];
						}
						$indentation--;
if($debug)
						echo str_repeat("&nbsp;", $indentation*2)."/$thisTag (finally assumed for double open)<br />\n";
					}
					if($lenient && in_array($thisTag, $tags_which_are_selfclosing)) $thisSelfClosing=true;
					
					$tags[$parent]['children'][] = $tagid;

					$tags[$tagid]['parent'] = $parent;
					$tags[$tagid]['tagname'] = $thisTag;
					if(($t=parseattrib($thisAttrib)) === false) {
						if($lenient) {
							$t=array();
						} else {
							$this->err="Could not parse attribute string within tag {$tagName} - ".htmlspecialchars($thisAttrib)."<br />\n";
							return false;
						}
					}
					$tags[$tagid]['attributes'] = $t;
					$tags[$tagid]['rawattrs'] = $thisAttrib;
					$tags[$tagid]['nodetype'] = 1;
					if(!$thisSelfClosing) {
if($debug)
						echo str_repeat("&nbsp;", $indentation*2)."$thisTag<br />\n";
						$parent=$tagid;
						$indentation++;
						$tag_stack[] = $thisTag;
					} else {
if($debug)
						echo str_repeat("&nbsp;", $indentation*2)."$thisTag/<br />\n";
					}
					if($dataparent===false) $dataparent=$parent;
					$tags[$dataparent]['children'][] = $tagid.".5";
					$tags[$tagid.".5"]['parent'] = $dataparent;
					$tags[$tagid.".5"]['cdata'] = $m[4][$i];
					$tags[$tagid.".5"]['nodetype'] = 3;
				} else if($thisClosing) {
					if(array_peek($tag_stack) == $thisTag) {
						//yay, it's simple!!
						$indentation--;
						$parent=$tags[$parent]['parent'];
						array_pop($tag_stack);
if($debug)
						echo str_repeat("&nbsp;", $indentation*2)."/$thisTag<br />\n";
					} else if($lenient && in_array($thisTag, $tags_which_are_selfclosing)) {
						//already handled it
if($debug)
						echo str_repeat("&nbsp;", $indentation*2)."/$thisTag (already handled)<br />\n";
						continue;
					} else if($lenient && in_array($thisTag, $tag_stack)) {
						//hmm, we should close up until we can close this normally
						while(array_peek($tag_stack) != $thisTag) {
							if(in_array($thisTag, $tags_which_are_selfclosing)) continue; //already handled!
							$indentation--;
							$t=array_peek($tag_stack);
if($debug)
							echo str_repeat("&nbsp;", $indentation*2)."/$t (assumed for /$thisTag)<br />\n";
							array_pop($tag_stack);
							$parent=$tags[$parent]['parent'];
						}
						array_pop($tag_stack);
						$parent=$tags[$parent]['parent'];
						$indentation--;
if($debug)
						echo str_repeat("&nbsp;", $indentation*2)."/$thisTag (finally)<br />\n";
					} else if($lenient) {
						//this case is ignored anyway, so ha!
						//echo str_repeat(" ", $indentation*2)."/$thisTag (doubly closed)\n";
					} else {
						$this->err="Weird code at ".htmlspecialchars($m[0][$i]). " - ".join(',', $tag_stack)."; closing={$thisClosing}";
						return false;
					}
					$tags[$parent]['cdata'][] = $m[4][$i];
				} else {
					$this->err="The tag at ".htmlspecialchars($m[0][$i]). " - ".join(',', $tag_stack)."; is neither opening nor closing";
					return false;
				}
			}
		} else {
			$this->err="Could not parse -- No tags?";
			return false;
		}
if($debug)
		echo "Done parsing.  Tree has ".count($tags)." nodes<br />\n";
		$this->parseTree=$tags;
		$this->parsedYet=true;
		return $tags;
	}
	
	function getError() {
		return $this->err;
	}

	function getElementsByTagname($tagName, $parent=false) {
		$tags=array();
		$t=strtolower($tagName);
		
		if(!$this->parsedYet) return false;
		
		if($parent !== false) {
			foreach($this->parseTree[$parent]['children'] as $tagid) {
				if($this->parseTree[$tagid]['tagname'] == $t) {
					$tags[] = $tagid;
				}
			}
		} else {
			foreach($this->parseTree as $tagid=>$tag) {
				if($tag['tagname'] == $t) {
					$tags[] = $tagid;
				}
			}
		}
		if(!count($tags)) return false;
		return $tags;
	}
	
	function getSiblings($nodeId) {
		if(!$this->parsedYet) return false;
		if(!isset($this->parseTree[$nodeId])) return false;
		if($nodeId==0) return array(0);
		return $this->parseTree[$this->parseTree[$nodeId]['parent']]['children'];
	}
	
	function getElementsByString($tag, $attr) {
		if(!$this->parsedYet) return false;
		$t=strtolower($tag);
		$a=trim($attr);
	
		foreach($this->parseTree as $tagid=>$tag) {
			if($tag['tagname'] == $t) {
				if(trim($tag['rawattrs']) == $a) {
					$tags[] = $tagid;
				}
			}
		}

		if(!count($tags)) return false;
		return $tags;
	}
	
	function nextSibling($nodeId) {
		if(!isset($this->parseTree[$nodeId])) return false;
		if(($nodes=$this->getSiblings($nodeId)) === false) return false;
		$pos=array_search($nodeId, $nodes);
		#echo $pos.":";
		#print_r($nodes);
		
		if(!isset($nodes[$pos+1])) return false;
		return $nodes[$pos+1];
	}
	function parentNode($nodeId) {
		if(!isset($this->parseTree[$nodeId])) return false;
		if($nodeId == 0) return false;
		return $this->parseTree[$nodeId]['parent'];
	}
	
	function firstChild($nodeId) {
		if(!$this->parsedYet) return false;
		if(!isset($this->parseTree[$nodeId])) return false;
		$children = $this->parseTree[$nodeId]['children'];
		list(,$v) = each($children);
		return $v;
	}
	
	/** For the time being, it ignores the collapseWhitespace setting */
	function innerHTML($nodeId, $includeSelf=false, $stripattrs=false) {
		$debug=false;
		$r=array();
		$tags = &$this->parseTree;
		if(!isset($tags[$nodeId])) return "";
		if($tags[$nodeId]['nodetype'] == 3) {
			//simple text node, return
if($debug)
			echo "T";
			return $tags[$nodeId]['cdata'];
		} else {
if($debug)
			echo "N";
			if(!$stripattrs) 
				$a=$tags[$nodeId]['rawattrs'];
			if(!isset($tags[$nodeId]['children'])) {
if($debug)
				echo "0";
				$r[]="<{$tags[$nodeId]['tagname']}{$a} />";
			} else {
if($debug)
				echo "#";
				if($includeSelf) $r[]="<{$tags[$nodeId]['tagname']}{$a}>";
				foreach($tags[$nodeId]['children'] as $v) {
					$r[] = $this->innerHTML($v,true,$stripattrs);
				}
				if($includeSelf) $r[]="</{$tags[$nodeId]['tagname']}>";
			}
		}
		return join('',$r);
	}
	/** This function will call itself recursively to grab children and join their whitespace */
	function innerText($nodeId,$recursing=false) {
		$r=array();
		$tags = &$this->parseTree;
		
		if(isset($tags[$nodeId])) {
			if($tags[$nodeId]['nodetype'] == 1 && $tags[$nodeId]['children']) {
				foreach($tags[$nodeId]['children'] as $v) {
					if($tags[$v]['nodetype'] == 3) {
						$r[] = $tags[$v]['cdata'];
					} else {
						//recurse
						array_merge($r, $this->innerText($v,true));
					}
				}
			} else if($tags[$nodeId]['nodetype'] == 3) {
				$r[] = $tags[$nodeId]['cdata'];
			}
		}
		
		if($this->collapseWhitespace) {
			for($i=0; $i < count($r) -1; $i++) {
				if(rtrim($r[$i]) != $r[$i]) {
					$r[$i] = rtrim($r[$i]);
					$r[$i+1] = ltrim($r[$i]);
				}
				
			}
			$r=join('',$r);
			$r=preg_replace("/[ \r\n\t]+/"," ",$r);
			if(!$recursing) $r=trim($r);
		} else {
			$r=join('',$r);
		}
		return $r;
	}
	
	function nodeType($el) {
		return $this->parseTree[$el]['nodetype'];
	}
	function tagName($el) {
		return $this->parseTree[$el]['tagname'];
	}
		
}

function parseattrib($str) {
	$r=array();
	if(preg_match_all("/(\w+)[ \n\t]*?=[ \n\t]*?\"(.*?)\"/", $str, $m)) {
		foreach($m[1] as $k=>$v) {	
			$r[$m[1][$k]] = $m[2][$k];
		}
	}
}
function parseattrib2($str) {
	$inequals=false;
	$inquote=false;
	$quotechar=false;
	$key="";
	for($i=0; $i < strlen($str); $i++) {
		if(!$inquote && is_whitespace($c)) continue;
		if(!$inquote) {
		#	if(
		}
	}
	return $r;
}

function is_whitespace($c) {
	if($i=="\n" || $i=="\t" || $i==" ") return true;
	return false;
}

function array_peek($a,$dokey=false) {
	$keys=array_reverse($a, true);
	list($k,$v) = each($keys);
	if($dokey) return $k;
	return $v;
}

?>
